;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; !!! You can edit following in order to change your key-bindings !!!!
;; If the "xref-key-binding" var is 'local, then xref
;; binding is done only for C and Java programming modes.

(provide 'xrefactory)

(if (or (not (boundp 'xref-key-binding))
		(eq xref-key-binding 'global))
	(progn
	  (global-set-key [(f7)] 'xref-delete-windows)
	  (global-set-key [(f8)] 'xref-completion)
	  (global-set-key [(control f6)] 'xref-listCxrefs)
	  (global-set-key [(f6)] 'xref-pushCxrefs)
	  (global-set-key [(f5)] 'xref-popCxrefs)
	  (global-set-key [(control f5)] 'xref-re-push)
	  (global-set-key [(f4)] 'xref-nextref)
	  (global-set-key [(control f4)] 'xref-this-symbol-next-ref)
	  ;;(global-set-key [(kp-add)] 'xref-this-symbol-next-ref)
	  (global-set-key [(f3)] 'xref-previousref)
	  (global-set-key [(control f3)] 'xref-this-symbol-previous-ref)
	  ;;(global-set-key [(kp-subtract)] 'xref-this-symbol-previous-ref)

	  ;; if you wish to bind Alt-space as completion and Alt-return for
	  ;; removing completion window, uncomment following
	  ;;(global-set-key "\M- " 'xref-completion)
	  ;;(global-set-key "\M-\r" 'xref-delete-windows)
	  )

  (if (eq xref-key-binding 'local)
	  (progn
  		;; here follows local key bindings for C and Java modes only
		;; ("xref-key-binding" must be 'local in order 
		;; that this binding takes effect).
		;;
		;; maybe you will need to customize the following loaded file name
		;; to one containing c-mode-map and java-mode-map definitions
		(load "cc-mode")

		(define-key c-mode-map [(f7)] 'xref-delete-windows)
		(define-key c-mode-map [(f8)] 'xref-completion)
		(define-key c-mode-map [(control f6)] 'xref-listCxrefs)
		(define-key c-mode-map [(f6)] 'xref-pushCxrefs)
		(define-key c-mode-map [(f5)] 'xref-popCxrefs)
		(define-key c-mode-map [(control f5)] 'xref-re-push)
		(define-key c-mode-map [(f4)] 'xref-nextref)
		(define-key c-mode-map [(control f4)] 'xref-this-symbol-next-ref)
		(define-key c-mode-map [(f3)] 'xref-previousref)
		(define-key c-mode-map [(control f3)] 'xref-this-symbol-previous-ref)
		(define-key c-mode-map "\e\t" 'xref-completion)
		(define-key c-mode-map "\M- " 'xref-completion)
		(define-key c-mode-map "\M-\r" 'xref-delete-windows)
		
		(define-key java-mode-map [(f7)] 'xref-delete-windows)
		(define-key java-mode-map [(f8)] 'xref-completion)
		(define-key java-mode-map [(control f6)] 'xref-listCxrefs)
		(define-key java-mode-map [(f6)] 'xref-pushCxrefs)
		(define-key java-mode-map [(f5)] 'xref-popCxrefs)
		(define-key java-mode-map [(control f5)] 'xref-re-push)
		(define-key java-mode-map [(f4)] 'xref-nextref)
		(define-key java-mode-map [(control f4)] 'xref-this-symbol-next-ref)
		(define-key java-mode-map [(f3)] 'xref-previousref)
		(define-key java-mode-map [(control f3)] 'xref-this-symbol-previous-ref)
		(define-key java-mode-map "\e\t" 'xref-completion)
		(define-key java-mode-map "\M- " 'xref-completion)
		(define-key java-mode-map "\M-\r" 'xref-delete-windows)
		))
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Here you can put the name of your default default values.
;; those values can be overriden by your .emacs file.
;; if you wish an alternative setting, just uncomment the
;; line after variable definition.

;; by default xref asks before starting to browse a javadoc URL
(if (not (boundp 'xref-ask-before-browse-javadoc)) 
	(defvar xref-ask-before-browse-javadoc t)
  )
;;(setq xref-ask-before-browse-javadoc nil)

;; by default multibyte buffer representation is disallowed
;; due to efficiency reasons, moreover pre-processing construction
;; browsing has some problems with multibytes
(if (not (boundp 'xref-allow-multibyte)) 
	(defvar xref-allow-multibyte nil)
  )
;;(setq xref-allow-multibyte t)

;; by default the automatic project selection is on.
(if (not (boundp 'xref-current-project)) 
	(defvar xref-current-project nil)
  )
;;(setq xref-current-project "/the/default/project")

;; by default the accessibility and linkage checks are not 
;; provided for proposed completions
(if (not (boundp 'xref-java-completion-access-check)) 
	(defvar xref-java-completion-access-check nil)
  )
(if (not (boundp 'xref-java-completion-linkage-check)) 
	(defvar xref-java-completion-linkage-check nil)
  )


;; coloring is off, too slow and not fit with reverse video.
(if (not (boundp 'xref-coloring)) 
	(defvar xref-coloring nil)
  )
;;(setq xref-coloring t)

;; highlighghting on mouse movements is on.
(if (not (boundp 'xref-mouse-highlight)) 
	(defvar xref-mouse-highlight t)
  )
;;(setq xref-mouse-highlight nil)

;; store only last few refactorings to undo
(if (not (boundp 'xref-multifile-undo-deep)) 
	(defvar xref-multifile-undo-deep 15)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Completion coloring
;;  you can choose your colors here !

(if (fboundp 'make-face)
	(progn
	  (if (not (boundp 'xref-list-default-face)) 
		  (make-face 'xref-list-default-face)
		)
	  (if (not (boundp 'xref-list-pilot-face)) 
		  (progn
			(make-face 'xref-list-pilot-face)
			(set-face-foreground 'xref-list-pilot-face "navy")
			))
	  (if (not (boundp 'xref-list-symbol-face)) 
		  (progn
			(make-face 'xref-list-symbol-face)
			(set-face-foreground 'xref-list-symbol-face "navy")
			))
	  (if (not (boundp 'xref-keyword-face)) 
		  (progn
			(make-face 'xref-keyword-face)
			(set-face-foreground 'xref-keyword-face "blue")
			))
	  )
 ;; do not know, how to make faces, set the coloring off
	(setq xref-coloring nil)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;     functions to load and save a source file, you may need to
;;     redefine them if you are using some kind of version control
;;     on your project

(defun xref-find-file (file-name)
  (find-file file-name)
)

(defun xref-save-some-buffers (flag)
  (save-some-buffers flag)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; here come definitions of Xref Menus, nothing more to setup.
;;

(defvar xref-home-directory "")

(autoload 'xref-search-in-completions "xref" "search id in completions" t)
(autoload 'xref-search-in-tag-file "xref" "search id in tag file" t)
(autoload 'xref-completion "xref" "complete identifier" t)
(autoload 'xref-pushCxrefs-force-ctree "xref" "push references throught class tree" t)
(autoload 'xref-pushCxrefs "xref" "go to the definition of a symbol" t)
(autoload 'xref-listCxrefs "xref" "list all references" t)
(autoload 'xref-popCxrefs "xref" "return from the last definition" t)
(autoload 'xref-nextref "xref" "next reference" t)
(autoload 'xref-previousref "xref" "previous reference" t)
(autoload 'xref-show-stack-top-symbol "xref" "show stack top symbol" t)
(autoload 'xref-delete-windows "xref" 
		"delete the window created by Xref" t)
(autoload 'xref-rename "xref" "safe rename" t)
(autoload 'xref-update-refs "xref" "update cross references" t)
(autoload 'xref-fast-update-refs "xref" "fast (partial) update of cross references" t)
(autoload 'xref-create-refs "xref" "create cross references" t)
(autoload 'xref-about "xref" "about Xref" t)

(autoload 'xref-project-set-active "xref" "set active Xrefactory project" t)
(autoload 'xref-project-new "xref" "create new Xrefactory project" t)
(autoload 'xref-project-active "xref" "show active Xrefactory project" t)
(autoload 'xref-project-edit-options "xref" "edit Xrefactory options" t)

(autoload 'xref-arg-push "xref" "push references on an argument" t)
(autoload 'xref-arg-delete "xref" "delete an argument" t)
(autoload 'xref-arg-insert "xref" "insert an argument" t)
(autoload 'xref-arg-shift "xref" "shift an argument to other position" t)
(autoload 'xref-arg-exchange "xref" "exchange two arguments" t)

(autoload 'xref-extract-region-to-function "xref" "extract region into a new function (in-out parameters)" t)
(autoload 'xref-extract-region-to-function-force-address "xref" "extract region into a new function (reference parameters)" t)
(autoload 'xref-extract-region-to-macro "xref" "extract region into a new macro" t)
(autoload 'xref-toggle-next-push-manual "xref" "xref toggle manual resolution flag" t)
(autoload 'xref-undo-last-refactoring "xref" "undo last refactoring" t)
(autoload 'xref-re-push "xref" "re-push last poped references" t)
(autoload 'xref-this-symbol-previous-ref "xref" "Go to the previous reference of the symbol under the cursor" t)
(autoload 'xref-this-symbol-next-ref "xref" "Go to the next reference of the symbol under the cursor" t)
(autoload 'xref-list-top-references "xref" "List references on the top of the stack" t)
(autoload 'xref-kill-xref-process "xref" "Kill currently running xref process" t)
(autoload 'xref-class-tree-show "xref" "Display current class hierarchy" t)
(autoload 'xref-ide-compile-file "xref" "Compile current file" t)
(autoload 'xref-ide-compile-dir "xref" "Compile files in current directory" t)
(autoload 'xref-ide-compile-project "xref" "Compile the current project" t)
(autoload 'xref-ide-previous-error "xref" "Move to the previous error" t)
(autoload 'xref-ide-run "xref" "Execute interactive command" t)




;; Now follows Xref menu definitions
;; Emacs

;; IDE menu
(defvar xref-ide-menu (make-sparse-keymap "Xref interface to Emacs IDE functions"))
(fset 'xref-ide-menu (symbol-value 'xref-ide-menu))
(define-key xref-ide-menu [xref-ide-run] '("Run" . xref-ide-run))
(define-key xref-ide-menu [xref-ide-preverror] '("Previous Error" . xref-ide-previous-error))
(define-key xref-ide-menu [xref-ide-nexterror] '("Next Error" . xref-ide-next-error))
(define-key xref-ide-menu [xref-ide-cprj] '("Compile Project" . xref-ide-compile-project))
(define-key xref-ide-menu [xref-ide-cdir] '("Compile Directory" . xref-ide-compile-dir))
(define-key xref-ide-menu [xref-ide-cfile] '("Compile File" . xref-ide-compile-file))

;; local browse menu
(defvar xref-lm-menu (make-sparse-keymap "Local Motion"))
(fset 'xref-lm-menu (symbol-value 'xref-lm-menu))
(define-key xref-lm-menu [xref-lm-next] '("Next Reference of This Symbol" . xref-this-symbol-next-ref))
(define-key xref-lm-menu [xref-lm-previous] '("Previous Reference of This Symbol" . xref-this-symbol-previous-ref))

(defvar xref-sb-menu (make-sparse-keymap "Browsing with Symbol Stack"))
(fset 'xref-sb-menu (symbol-value 'xref-sb-menu))
(define-key xref-sb-menu [xref-sb-force-dialog] '("Force Manual Resolution for Next Push" . xref-toggle-next-push-manual))
(define-key xref-sb-menu [xref-sb-repush] '("Re-push Poped References" . xref-re-push))
(define-key xref-sb-menu [xref-sb-sep3] '("--"))
(define-key xref-sb-menu [xref-sb-pop-and-ret] '("Pop References and Return" . xref-popCxrefs))
(define-key xref-sb-menu [xref-sb-pop] '("Pop References" . xref-poponly))
(define-key xref-sb-menu [xref-sb-sep2] '("--"))
(define-key xref-sb-menu [xref-sb-current-sym] '("Show Symbol on Top" . xref-show-stack-top-symbol))
(define-key xref-sb-menu [xref-sb-caller] '("Initial Position" . xref-caller-reference))
(define-key xref-sb-menu [xref-sb-list-top] '("List References on Top" . xref-list-top-references))
(define-key xref-sb-menu [xref-sb-current] '("Current Reference" . xref-current-reference))
(define-key xref-sb-menu [xref-sb-def] '("Definition Reference" . xref-definition-reference))
(define-key xref-sb-menu [xref-sb-next] '("Next Reference" . xref-nextref))
(define-key xref-sb-menu [xref-sb-previous] '("Previous Reference" . xref-previousref))
(define-key xref-sb-menu [xref-sb-sep1] '("--"))
(define-key xref-sb-menu [xref-sb-push-ctree] '("Push References via Manual Resolution" . xref-pushCxrefs-force-ctree))
(define-key xref-sb-menu [xref-sb-push-and-list] '("Push References and List Top" . xref-listCxrefs))
(define-key xref-sb-menu [xref-sb-push-and-go] '("Push References and Goto Definition" . xref-pushCxrefs))
(define-key xref-sb-menu [xref-sb-push] '("Push References" . xref-push-references))


(defvar xref-arg-menu (make-sparse-keymap "Argument Manipulations"))
(fset 'xref-arg-menu (symbol-value 'xref-arg-menu))
(define-key xref-arg-menu [xref-arg-exchange] '("Exchange Arguments" . xref-arg-exchange))
(define-key xref-arg-menu [xref-arg-shift] '("Shift Argument" . xref-arg-shift))
(define-key xref-arg-menu [xref-arg-insert] '("Insert Argument" . xref-arg-insert))
(define-key xref-arg-menu [xref-arg-dalete] '("Delete Argument" . xref-arg-delete))
(define-key xref-arg-menu [xref-arg-push] '("Manual Argument Edit" . xref-arg-push))

(defvar xref-extr-menu (make-sparse-keymap "Region Extraction"))
(fset 'xref-extr-menu (symbol-value 'xref-extr-menu))
(define-key xref-extr-menu [xref-extr-macro] '("Macro" . xref-extract-region-to-macro))
(define-key xref-extr-menu [xref-extr-function] '("Function" . xref-extract-region-to-function))

(defvar xref-search-menu (make-sparse-keymap "Search Symbol"))
(fset 'xref-search-menu (symbol-value 'xref-search-menu))
(define-key xref-search-menu [xref-search-tag] '("tag file" . 
xref-search-in-tag-file))
(define-key xref-search-menu [xref-search-compl] '("Context Completions" .
xref-search-in-completions))

(defvar xref-project-menu (make-sparse-keymap "Project"))
(fset 'xref-project-menu (symbol-value 'xref-project-menu))
(define-key xref-project-menu [xref-prj-edit] '("Edit Options" . 
xref-project-edit-options))
(define-key xref-project-menu [xref-prj-show-active] '("Show Active" . 
xref-project-active))
(define-key xref-project-menu [xref-prj-set-active] '("Set Active" . 
xref-project-set-active))
(define-key xref-project-menu [xref-prj-new] '("New" . 
xref-project-new))

(defvar xref-menu (make-sparse-keymap "Xref"))
(define-key xref-menu [xref-about] '("About Xref" . xref-about))
(define-key xref-menu [xref-kill] '("Kill xref process" . xref-kill-xref-process))
(define-key xref-menu [separator-buffers2] '("--"))
(define-key xref-menu [xref-undo] '("Undo last refactoring" . xref-undo-last-refactoring))
(define-key xref-menu [(f7)] '("Remove Xref Window" . xref-delete-windows))
(define-key xref-menu [(f8)] '("Complete identifier" . xref-completion))
(define-key xref-menu [xref-search-menu] '("Search Symbol in" . xref-search-menu))
(define-key xref-menu [separator-buffers5] '("--"))
(define-key xref-menu [xref-extr-menu] '("Extract Region into a" . xref-extr-menu))
(define-key xref-menu [xref-arg-menu] '("Argument Manipulations" . xref-arg-menu))
(define-key xref-menu [xref-rename] '("Safe Rename" . xref-rename))
(define-key xref-menu [separator-buffers4] '("--"))
(define-key xref-menu [xref-class-tree] '("View Class Tree" . xref-class-tree-show))
(define-key xref-menu [xref-sb-menu] '("Browsing with Symbol Stack" . xref-sb-menu))
(define-key xref-menu [xref-lm-menu] '("Local Motion" . xref-lm-menu))
(define-key xref-menu [separator-buffers3] '("--"))
(define-key xref-menu [xref-fast-update-refs] '("Fast Update of Xref Tag File" . xref-fast-update-refs))
(define-key xref-menu [xref-update-refs] '("Update Xref Tag File" . xref-update-refs))
(define-key xref-menu [xref-create-refs] '("Create Xref Tag File" . xref-create-refs))
(define-key xref-menu [separator-buffers6] '("--"))
(define-key xref-menu [xref-ide-menu] '("Emacs IDE" . xref-ide-menu))
(define-key xref-menu [xref-project-menu] '("Project" . xref-project-menu))

;; XEmacs
(defvar xref-xemacs-ide-menu
  '("XEmacs IDE"
   ["Compile File" xref-ide-compile-file t]
   ["Compile Directory" xref-ide-compile-dir t]
   ["Compile Project" xref-ide-compile-project t]
   ["Next Error" xref-ide-next-error t]
   ["Previous Error" xref-ide-previous-error t]
   ["Run" xref-ide-run t]
	) "Xref interface to XEmacs IDE functions" 
)

(defvar xref-xemacs-lm-menu
  '("Local Motion"
   ["Previous Reference of This Symbol" xref-this-symbol-previous-ref t]
   ["Next Reference of This Symbol"		xref-this-symbol-next-ref t]
	) "Xref local motion menu for XEmacs" 
)

(defvar xref-xemacs-sb-menu
  '("Browsing with Symbol Stack"
   ["Push References" xref-push-references t]
   ["Push References and Goto Definition" xref-pushCxrefs t]
   ["Push References and List Top" xref-listCxrefs t]
   ["Push References via Manual Resolution" xref-pushCxrefs-force-ctree t]
	"-----"
   ["Previous Reference" xref-previousref t]
   ["Next Reference" xref-nextref t]
   ["Definition Reference" xref-definition-reference t]
   ["Current Reference" xref-current-reference t]
   ["List References on Top" xref-list-top-references t]
   ["Initial Position" xref-caller-reference t]
   ["Show Symbol on Top" xref-show-stack-top-symbol t]
	"-----"
   ["Pop References" xref-poponly t]
   ["Pop References and Return" xref-popCxrefs t]
	"-----"
   ["Re-push Poped References" xref-re-push t]
   ["Force Manual Resolution for Next Push" xref-toggle-next-push-manual t]
	) "Xref Source Browsing menu for XEmacs" 
)

(defvar xref-xemacs-arg-menu
  '("Argument Manipulations"
   ["Manual Argument Edit"			xref-arg-push t]
   ["Delete Argument"			xref-arg-delete t]
   ["Insert Argument"			xref-arg-insert t]
   ["Shift Argument"			xref-arg-shift t]
   ["Exchange Arguments"		xref-arg-exchange t]
	) "Xref argument manipulations menu for XEmacs" 
)

(defvar xref-xemacs-extr-menu
  '("Extract Region"
   ["into a Function"		xref-extract-region-to-function t]
   ["into a Macro"			xref-extract-region-to-macro t]
	) "Xref region extraction menu for XEmacs" 
)

(defvar xref-xemacs-search-menu
  '("Search Symbol"
   ["Search in Context Completions"		xref-search-in-completions t]
   ["Search in Tag File"				xref-search-in-tag-file t]
	) "Xref search menu for XEmacs" 
)

(defvar xref-xemacs-project-menu
  '("Project"
	["New"		        xref-project-new t]
	["Set Active"		xref-project-set-active t]
	["Show Active"		xref-project-active t]
	["Edit Options"		xref-project-edit-options t]
	) "Xref Project menu for XEmacs" 
)

(defvar xref-xemacs-menu
  '("Xref"
	"------"
   ["Create Xref Tag File"			xref-create-refs t]
   ["Update Xref Tag File"			xref-update-refs t]
   ["Fast Update of Xref Tag File"	xref-fast-update-refs t]
	"--"
	;; browsing menus will come here
   ["View Class Tree"	            xref-class-tree-show t]
	"-----"
   ["Safe Rename"					xref-rename t]
	"----"
   ["Complete identifier"			xref-completion t]
   ["Remove Xref Window"			xref-delete-windows t]
   ["Undo last refactoring"		    xref-undo-last-refactoring t]
	"--"
   ["Kill xref process"				xref-kill-xref-process t]
   ["About Xref"					xref-about t]
	) "Xref menu for XEmacs" 
)

(defvar xref-get-event)

(if (string-match "XEmacs" emacs-version)
	(progn
	;; XEmacs
		(setq xref-get-event 'next-command-event)
		(if window-system 
			(progn 
				(add-submenu nil xref-xemacs-menu)
				(add-submenu '("Xref") xref-xemacs-project-menu "------")
				(add-submenu '("Xref") xref-xemacs-ide-menu "------")
				(add-submenu '("Xref") xref-xemacs-lm-menu "View Class Tree")
				(add-submenu '("Xref") xref-xemacs-sb-menu "View Class Tree")
				(add-submenu '("Xref") xref-xemacs-arg-menu "----")
				(add-submenu '("Xref") xref-xemacs-extr-menu "----")
				(add-submenu '("Xref") xref-xemacs-search-menu "Complete identifier")
			)
		)
	)
	;; Emacs
	;; (global-set-key [C-f6] 'xref-listCxrefs)
	(setq xref-get-event 'read-event)
	(let ((menu (lookup-key global-map [menu-bar])))
		(define-key-after menu [xref] 
		   (cons "Xref" xref-menu)
			(car (nth (- (length menu) 3) menu))
		)
	)
)


